/*
 * Program:   R  A  C
 * 
 * RAC - Rows and Columns, the text extraction tool 
 * http://aurelio.net/rac
 *
 * Copyright 2003  Aurelio Marinho Jargas
 *                 Thobias Salazar Trevisan
 *
 * Please address all bugs and comments to:
 *    verde@aurelio.net
 *    thobias@thobias.org
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, version 2.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You have received a copy of the GNU General Public License along
 *  with this program, on the COPYING file.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>

#define PROGRAM_NAME "rac"

#define VERSION "1.0"

#define AUTHORS "Aurelio Marinho Jargas, Thobias Salazar Trevisan"

#define BUG_ADDRESS "verde@aurelio.net, thobias@thobias.org"

/* matrix allocate memory (step) */
#define LINE_SIZE 100
#define LINE_NUM  200

#define TYPE_RANGE_LINE 0
#define TYPE_RANGE_COL  1

/* command allocate memory (step) */
#define CMD_SIZE 15

#ifndef LONG_MAX
#define LONG_MAX   2147483647L
#endif

struct struct_rac_data {
	char **line;
	long int num_line;
	long int *num_chars_line;
	long int line_start, line_end;
	char *col_start, *col_end;
	FILE *stream;
	long int STEP_LINE;
	long int STEP_COL;
	int TYPE;
};

void usage(int status);
void get_file(struct struct_rac_data *p_rac_data);
void check_col(long int *line, long int *col,struct struct_rac_data *p_rac_data);
int check_lines(struct struct_rac_data *p_rac_data);
void get_type(char *command,struct struct_rac_data *p_rac_data);
void exec_range_lines(char *command,struct struct_rac_data *p_rac_data);
void exec_range_cols(char *command,struct struct_rac_data *p_rac_data);
void exec_cmd(char *command,struct struct_rac_data *p_rac_data);
void get_ranges(char *command,struct struct_rac_data *p_rac_data);

